@echo off
@echo.

rem ------------------------------------------------------------------------
rem Batch file to extract FILE_ID.DIZ from archive..
rem %1 = file to test on.
rem
rem If a file called FAIL.TXT exist, the upload will be deleted and credits
rem will be taken, the contents of FAIL.TXT will be mailed as a reason for
rem failing to the uploader (If uploader is not online).
rem ------------------------------------------------------------------------

if "%1" == ""   goto failure
if not exist %1 goto end
if exist crcfail.txt del crcfail.txt>nul
if exist file_id.diz del file_id.diz>nul

testfile %1 zip arj rar lha lzh dms exe ace tgz
if errorlevel == 98 goto end
if errorlevel == 9 goto tgz
if errorlevel == 8 goto ace
if errorlevel == 7 goto exe
if errorlevel == 6 goto dms
if errorlevel == 5 goto lha
if errorlevel == 4 goto lha
if errorlevel == 3 goto rar
if errorlevel == 2 goto arj
if errorlevel == 1 goto zip
goto end

:zip
pkunzip %1 file_id.diz -o>nul
if exist file_id.diz attrib -h -r -s file_id.diz>nul
if exist file_id.diz txtcon file_id.diz>nul
pkunzip -t %1>nul
if errorlevel 1 goto crcfail
deltree /y virtemp
md virtemp
cd virtemp
pkunzip -d -o %1>nul
d:\dos\tbav\tbscan32 mono compat ignofile old noboot nomem nohmem batch
cd..
deltree /y virtemp
if errorlevel 5 goto heuristic
if errorlevel 4 goto infected
goto end

:arj
arj x %1 file_id.diz -Y>nul
if exist file_id.diz attrib -h -r -s file_id.diz>nul
arj t -y %1>nul
if errorlevel 3 goto crcfail
deltree /y virtemp
md virtemp
cd virtemp
arj x -y %1>nul
d:\dos\tbav\tbscan32 mono compat ignofile old noboot nomem nohmem batch
cd..
deltree /y virtemp
if errorlevel 4 goto infected
goto end

:lha
lha x %1 file_id.diz>nul
if exist file_id.diz txtcon file_id.diz>nul
lha t /m+ %1>nul
if errorlevel 2 goto crcfail
deltree /y virtemp
md virtemp
cd virtemp
lha x %1>nul
d:\dos\tbav\tbscan32 mono compat ignofile old noboot nomem nohmem batch
cd..
deltree /y virtemp
if errorlevel 4 goto infected
goto end

:dms
dmsdiz %1>nul
if exist file_id.diz txtcon file_id.diz>nul
goto end

:exe
exediz %1>nul
if exist file_id.diz txtcon file_id.diz>nul
goto end

:rar
rar e %1 file_id.diz -y -c- -ep -cfg->nul
if exist file_id.diz attrib -h -r -s file_id.diz>nul
rar t -y %1>nul
if errorlevel 3 goto crcfail
deltree /y virtemp
md virtemp
cd virtemp
rar e %1 -y -c- -ep -cfg->nul
d:\dos\tbav\tbscan32 mono compat ignofile old noboot nomem nohmem batch
cd..
deltree /y virtemp
if errorlevel 4 goto infected
goto end

:ace
ace e -c- -ep -yo -y %1 file_id.diz>nul
if exist file_id.diz attrib -h -r -s file_id.diz>nul

:tgz
gzip -f -d %1 file_id.diz
if exist file_id.diz attrib -h -r -s file_id.diz>nul

:failure
cls
echo GETDIZ.BAT, part of FOOD! Endeavour Trader, for internal use only!
goto end

:crcfail
echo @X30         CRC Error in archive...             @X07>fail.txt
goto end

:infected
echo @X30       Virus detected in archive...          @X07>fail.txt
goto end

:end
